c....&................................................................72
      implicit none
      integer nv,nm,ndy,nyr,ngr,npft,ncol,nmax
      parameter (nm=12,ndy=366,nmax=200)
      real*4 var_day(ndy),var_mth(nm),var_pft(nmax),var_yr
      integer iv,iday,im,nd,igr,ipft,icol,imean,iyr,iyear,ileap,icentury
      integer iyr0,iyrf
      real*4 xlg,xlt
      real*4 r100,r4
      character*4 year,yr0,yrf
      integer kdin,kdout,kn,ke,kf,ifiltype
      character*100 sdat,dir_in,dir_out,fnam
      character*20  fext
      character*10  form
      character*20  sdat1 
      character*36  prtform 
      character*200 filename     
           
      open(7,file='./status_mean_day.res')
       
      open(5,file='./mean_day_to_month_CARAIB.dat')
100   read(5,'(a100)')sdat
      if (sdat(1:1).eq.';') goto 100           
      read(sdat,*)nv
101   read(5,'(a100)')sdat
      if (sdat(1:1).eq.';') goto 101           
      read(sdat,*)ngr
102   read(5,'(a100)')sdat
      if (sdat(1:1).eq.';') goto 102           
      read(sdat,*)iyr0
103   read(5,'(a100)')sdat
      if (sdat(1:1).eq.';') goto 103           
      read(sdat,*)iyrf
104   read(5,'(a100)')sdat
      if (sdat(1:1).eq.';') goto 104           
      read(sdat,*)ileap                        
105   read(5,'(a100)')sdat
      if (sdat(1:1).eq.';') goto 105           
      read(sdat,*)npft
106   read(5,'(a100)')dir_in
      if (dir_in(1:1).eq.';') goto 106
      call charlen(dir_in,kdin)
107   read(5,'(a100)')dir_out
      if (dir_out(1:1).eq.';') goto 107
      call charlen(dir_out,kdout)
      
      
      nyr = iyrf-iyr0+1
      
      write(yr0,'(i4)')iyr0
      call check_year(yr0)            
      write(yrf,'(i4)')iyrf
      call check_year(yrf)  
      
      do iv = 1, nv 

       write(*,*)'Variable No :',iv      
       write(7,*)'Variable No :',iv    
       
200    read(5,'(a20,a10,a20,a100)')sdat1,form,fext,fnam
       if (sdat1(1:1).eq.';') goto 200
       
       read(sdat1,*)ifiltype,imean
       if (ifiltype.ge.3) read(sdat1,*)ifiltype,imean,ncol       
       
       call charlen3(fnam,fext,form,kn,ke,kf)
       
       if (ifiltype.eq.0) then         
         write(prtform,'(a12,i3,a4,a10,a2)')
     &      '(2(1x,f8.3),',nm,'(1x,',form(1:kf),'))'
       else if (ifiltype.le.2) then
         write(prtform,'(a12,i3,a4,a10,a2)')
     &      '(2(1x,f8.3),',npft,'(1x,',form(1:kf),'))'
       else 
         write(prtform,'(a12,i3,a4,a10,a2)')
     &      '(2(1x,f8.3),',ncol,'(1x,',form(1:kf),'))'
       endif            
                 
      
       do iyr = 1, nyr
        iyear = iyr0-1+iyr
        write(year,'(i4)')iyear
        call check_year(year)	
        write(*,'(a6,a4)')'Year: ',year        	       
        write(7,'(a6,a4)')'Year: ',year       
        open(11,file=dir_in(1:kdin)//fnam(1:kn)//year//fext(1:ke))       
     
c Determination of leap years according to year number iyear   
c -----------------------------------------------------------
c     nd = number of days in the current year
c If ileap = 1, leap years are taken into account (nd = 365 or 366), 
c otherwise nd = 365 (ileap=0) or nd = 360 (ileap=2).


        if (ileap.eq.0) then
	 nd = 365
	elseif  (ileap.eq.1) then
         r100 = mod(iyear,100)
         if (r100.eq.0) then
          icentury = iyear/100
	  r4 = mod(icentury,4)
         else     
          r4 = mod(iyear,4)
         endif 
         if (r4.eq.0) then 
          nd = 366 
         else
	  nd = 365
         endif
	elseif  (ileap.eq.2) then 
	 nd = 360
	else
	 write(*,*)'ILEAP not equal to 0, 1 or 2: ILEAP = ',ileap
	 write(*,*)'PROGRAM STOP'
	 stop
        endif
	    
       
        if (dir_in(1:kdin).eq.dir_out(1:kdout)) then
	 filename=dir_out(1:kdout)//fnam(1:kn)//year//'mth'//fext(1:ke)
        else
         filename=dir_out(1:kdout)//fnam(1:kn)//year//fext(1:ke)
        endif
	
	open(21,file=TRIM(filename))
     
        if (ifiltype.eq.0) then 
         do igr = 1, ngr
          read(11,*)xlg,xlt,(var_day(iday),iday=1,nd)
          call monthly_mean(var_day,nd,imean,ileap,var_mth)
          write(21,prtform)xlg,xlt,(var_mth(im),im=1,nm)
         end do
	elseif (ifiltype.eq.1) then
         do igr = 1, ngr
          read(11,*)xlg,xlt,(var_pft(ipft),ipft=1,npft)
          write(21,prtform)xlg,xlt,(var_pft(ipft),ipft=1,npft)
         end do
	elseif (ifiltype.eq.2) then
         do igr = 1, ngr
	  read(11,*)xlg,xlt
	  do ipft = 1, npft
           read(11,*)(var_day(iday),iday=1,nd)
	   call var_mean(var_day,nd,imean,var_yr)
	   var_pft(ipft)=var_yr
	  end do
          write(21,prtform)xlg,xlt,(var_pft(ipft),ipft=1,npft)
         end do	
	elseif (ifiltype.eq.3) then
         do igr = 1, ngr
          read(11,*)xlg,xlt,(var_pft(icol),icol=1,ncol)
          write(21,prtform)xlg,xlt,(var_pft(icol),icol=1,ncol)
         end do
	elseif (ifiltype.eq.4) then
         do igr = 1, ngr
	  read(11,*)xlg,xlt
	  do icol = 1, ncol
           read(11,*)(var_day(iday),iday=1,nd)
	   call var_mean(var_day,nd,imean,var_yr)
	   var_pft(icol)=var_yr
	  end do
          write(21,prtform)xlg,xlt,(var_pft(icol),icol=1,ncol)
         end do	
	endif	 
	
	close (11)
	close (21)
      
       end do
       
      end do
      
      close (5)
      close (7)
      
      stop
      end
      

      subroutine monthly_mean(var_day,nd,imean,ileap,var_mth)
c     -------------------------------------------------------

c     This subroutine calculates monthly means or monthly sum from a 
c     yearly series of daily values
c     INPUTS:
c        var_day : vector with the daily values (first 365 values for 
c                  normal years and all 366 values for leap years)
c        nd : number of days in the year (365 or 366)
c        imean : select mean or sum
c              imean = -1 for a sum (cumulative value as for monthly 
c                          precipitation) 
c              imean = 0 for a mean (e.g., for temperature)
c        ileap : use of leap years (ileap=1) 
c                or not (ileap=0 -> nd=365; ileap=2 -> nd=360) 
c     OUTPUT:
c        var_mth : vector with 12 monthly means or sums

c     ----------------------------------------------------------------

      implicit none
      
      integer nm,ndy
      parameter (nm=12,ndy=366)
      integer mlength(nm),imonth(ndy)
      real*4 var_day(ndy),var_mth(nm)
      integer iday,im,nd,iday1,iday2,imean,ileap
      
      if (ileap.eq.2) then
       do im = 1, nm
        mlength(im)=30
       end do
      else
       mlength(1)=31
       mlength(2)=28
       mlength(3)=31 
       mlength(4)=30
       mlength(5)=31
       mlength(6)=30
       mlength(7)=31 
       mlength(8)=31
       mlength(9)=30
       mlength(10)=31
       mlength(11)=30
       mlength(12)=31                  
      endif
      if (nd.eq.366) mlength(2)=29
      if (nd.eq.365) mlength(2)=28
      if (nd.eq.360) mlength(2)=30
      
      do iday = 1, nd
         imonth(iday) = 1
      end do
      iday1 = 1
      iday2 = mlength(1)
      do im = 2, nm
         iday1 = iday1 + mlength(im-1)
         iday2 = iday2 + mlength(im)
         do iday = iday1, iday2
            imonth(iday) = im
         end do
      end do      
           
      do im = 1, nm
       var_mth(im)=0.
      end do
      
      
      do iday = 1, nd
       im=imonth(iday)
       if (imean.eq.0) then
c         write(7,*)iday,im,mlength(im),var_day(iday),var_mth(im)
         var_mth(im)=var_mth(im)+var_day(iday)/float(mlength(im))
       elseif (imean.eq.-1) then
         var_mth(im)=var_mth(im)+var_day(iday)
       else
         write(7,*)'Bad value of imean: ',imean
	 write(7,*)'Program stop'
	 stop
       endif
      end do
      
      return
      end

      subroutine var_mean(var_i,ni,imean,var)
c     --------------------------------------------

c     This subroutine calculates annual mean or annual sum from a 
c     yearly series of daily/monthly values
c     INPUTS:
c        var_i : vector with the daily/monthly values 
c        ni : number of days/months in the year (365 or 366 / 12)
c        imean : select mean or sum
c              imean = -1 for a sum (cumulative value as for monthly 
c                          precipitation) 
c              imean = 0 for a mean (e.g., for temperature)
c     OUTPUT:
c        var : annual mean or sum of the variable

c     ----------------------------------------------------------------

      implicit none
      
      integer ni
      real*4 var_i(ni),var
      integer i,imean
               
      var=0.
            
      do i = 1, ni
       if (imean.eq.0) then
         var=var+var_i(i)/float(ni)
       elseif (imean.eq.-1) then
         var=var+var_i(i)
       else
         write(7,*)'Bad value of imean: ',imean
	 write(7,*)'Program stop'
	 stop
       endif
      end do
      
      return
      end      
      

c=======================================================================
c***********************************************************************
      subroutine charlen(name,kn)
c***********************************************************************
c=======================================================================

c=======================================================================
c   Subroutine for counting the number of letters in a character*80 
c   variable
c=======================================================================
      implicit none
      integer kn
      character*100 name
      kn = 0
    1 continue
      kn = kn + 1
      if(name(kn:kn) .ne. ' ') goto 1
      kn = kn - 1
      return 
      end


         
c=======================================================================
c***********************************************************************
      subroutine charlen3(fnam,fext,form,kn,ke,kf)
c***********************************************************************
c=======================================================================

c=======================================================================
c   Subroutine for counting the number of letters in three character 
c   variables (*100, *20 and *10)
c=======================================================================
      implicit none
      integer kn,ke,kf
      character*100 fnam
      character*20 fext
      character*10 form
      
      kn = 0
    1 continue
      kn = kn + 1
      if(kn.eq.101) goto 2
      if(fnam(kn:kn) .ne. ' ') goto 1
    2 continue
      kn = kn - 1
      
      ke = 0
    3 continue
      ke = ke + 1
      if(ke.eq.21) goto 4
      if(fext(ke:ke) .ne. ' ') goto 3
    4 continue
      ke = ke - 1 
      
      kf = 0
    5 continue
      kf = kf + 1
      if(kf.eq.11) goto 6
      if(form(kf:kf) .ne. ' ') goto 5
    6 continue
      kf = kf - 1      
           
      
      return 
      end      

c=======================================================================
c***********************************************************************       
      subroutine check_year(year)
c***********************************************************************
c=======================================================================
c=======================================================================
c   Subroutine for replacing blank (space) by 0 in a 4 character string
c=======================================================================      
      implicit none
      character*4 year
      integer k
      
      do k = 1,4
       if (year(k:k).eq.' ') year(k:k)='0'
      enddo
      
      return
      end      
       
