c....&................................................................72
      implicit none
      integer nv,nm,ngr,nyr,nm_max,icd,ipix
      parameter (nm_max=1000)
      real*8 var_year(nm_max),var_mean(nm_max)
      integer iv,im,igr,iyr,iyear,iyr0,iyrf,kn,ke,kf,ksl,ksv,iout
      integer iu_i
      real*8 xlg,xlt
      character*4 year,yr0,yrf
      character*100 fnam,out_dir
      character*250 fout
      character*20  fext
      character*10  form 
      character*36  prtform
      character*10   sdat    
      
      open(5,file='./mean_clim_CARAIB.dat')
           
      read(5,*)nv
      read(5,*)ngr
      read(5,*)iyr0
      read(5,*)iyrf
      read(5,*)iout
      read(5,'(a100)')out_dir
      if (iout.ne.0)then
        write(*,*)'Output directory: ',out_dir
        call make_directory(out_dir)
      endif
      
      nyr = iyrf-iyr0+1
      
      write(yr0,'(i4)')iyr0
      call check_year(yr0)            
      write(yrf,'(i4)')iyrf
      call check_year(yrf)
      

      do iv = 1, nv 
      
       write(*,*)'Variable No :',iv    
       
200    read(5,'(a10,a10,a20,a100)')sdat,form,fext,fnam
       if (sdat(1:1).eq.';') goto 200
       
       read(sdat,*)icd,nm       
       
       call charlen3(fnam,fext,form,kn,ke,kf,ksl)

c       write(*,*)'kn=',kn,' fnam:',fnam
c       write(*,*)'ke=',ke,' fext:',fext
c       write(*,*)'iout=',iout

       if (iout.eq.0) then 
        fout=fnam(1:kn)//'MEAN'//yr0//'_'//yrf//fext(1:ke)
       else
        ksv=ksl+1
        fout=trim(out_dir)
     &       //fnam(ksv:kn)//'MEAN'//yr0//'_'//yrf//fext(1:ke)
       endif 
        
       write(*,*)'Open file: ',trim(fout)         
       open(1,file=trim(fout))  
       
       if (icd.eq.0) then
         write(prtform,'(a12,i3,a4,a10,a2)')
     &      '(2(1x,f8.3),',nm,'(1x,',form(1:kf),'))'
       else
         write(prtform,'(a15,i3,a4,a10,a2)')
     &      '(i6,2(1x,f8.3),',nm,'(1x,',form(1:kf),'))'
       endif  
                     
       do iyr = 1, nyr
        iyear = iyr0-1+iyr
        write(year,'(i4)')iyear
        call check_year(year)	       
        write(*,'(a6,a4)')'Year: ',year              
	iu_i=10+iyr
        open(iu_i,file=fnam(1:kn)//year//fext(1:ke))
       end do
       
       do igr = 1, ngr
        do im = 1, nm
	 var_mean(im)=0.
	end do
        
        do iyr = 1, nyr
	 iu_i=10+iyr
	 if (icd.eq.0) then     
           read(iu_i,*)xlg,xlt,(var_year(im),im=1,nm)
	 else
	   read(iu_i,*)ipix,xlg,xlt,(var_year(im),im=1,nm)
	 endif
         do im = 1, nm
	  var_mean(im)=var_mean(im)+var_year(im)/float(nyr)
	 end do
	end do

        if (icd.eq.0) then
         write(1,prtform)xlg,xlt,(var_mean(im),im=1,nm)
	else
	 write(1,prtform)ipix,xlg,xlt,(var_mean(im),im=1,nm)
	endif
       end do
       
       close (1)
       
       do iyr = 1, nyr
        close (iu_i)
       end do
       
      end do
      
      close (5)
      
      stop
      end
      


         
c=======================================================================
c***********************************************************************
      subroutine charlen3(fnam,fext,form,kn,ke,kf,ksl)
c***********************************************************************
c=======================================================================

c=======================================================================
c   Subroutine for counting the number of letters in three character 
c   variables (*100, *20 and *10)
c=======================================================================

      implicit none
      integer kn,ke,kf,ksl
      character*100 fnam
      character*20 fext
      character*10 form
     
      ksl = 0
      kn = 0
    1 continue
      kn = kn + 1
      if(kn.eq.101) goto 2
      if(fnam(kn:kn) .eq. '/') ksl=kn
      if(fnam(kn:kn) .ne. ' ') goto 1
    2 continue
      kn = kn - 1
      
      ke = 0
    3 continue
      ke = ke + 1
      if(ke.eq.21) goto 4
      if(fext(ke:ke) .ne. ' ') goto 3
    4 continue
      ke = ke - 1 
      
      kf = 0
    5 continue
      kf = kf + 1
      if(kf.eq.11) goto 6
      if(form(kf:kf) .ne. ' ') goto 5
    6 continue
      kf = kf - 1      
           
      
      return 
      end      

c=======================================================================
c***********************************************************************       
      subroutine check_year(year)
c***********************************************************************
c=======================================================================
c=======================================================================
c   Subroutine for replacing blank (space) by 0 in a 4 character string
c=======================================================================      
      character*4 year
      integer k
      
      do k = 1,4
       if (year(k:k).eq.' ') year(k:k)='0'
      enddo
      
      return
      end
      
      
c***********************************************************************      
      subroutine make_directory(out_dir)
c***********************************************************************
      implicit none
      character*100 out_dir
      character*250 command 
 


      command='mkdir -p '//trim(out_dir)
      call system(command)      

 
      return
      end      
