c....&...1.........2.........3.........4.........5.........6.........7..
      implicit double precision (a-h,o-z)
c ngr_car=number of pixels (to be changed by user) 
      integer ngr_max,ngr_car,nm,ngr_GCM     
      parameter(ngr_max=65000,nm=12)          !CHANGER NBRE DE PIXEL
      common /earth/ radius      
      dimension xlg(ngr_max),xlt(ngr_max)
     &         ,elev(ngr_max),wgh(ngr_max),land(ngr_max)
      dimension temp(ngr_max,nm),prcp(ngr_max,nm)
     &         ,shrp(ngr_max,nm),rhup(ngr_max,nm)
     &         ,dtep(ngr_max,nm),tmxp(ngr_max,nm)
     &         ,tmnp(ngr_max,nm),wndp(ngr_max,nm)     
     &         ,tem1(ngr_max,nm),prc1(ngr_max,nm)
     &         ,shr1(ngr_max,nm),rhu1(ngr_max,nm)
     &         ,dte1(ngr_max,nm),tmx1(ngr_max,nm)
     &         ,tmn1(ngr_max,nm),wnd1(ngr_max,nm)
      dimension tem0(nm),prc0(nm),shr0(nm),rhu0(nm),dte0(nm)
     &         ,tmx0(nm),tmn0(nm),wnd0(nm)
     &         ,temcor(nm),prccor(nm),shrcor(nm),rhucor(nm),dtecor(nm)
     &         ,tmxcor(nm),tmncor(nm),wndcor(nm)
     &         ,temact(nm),prcact(nm),shract(nm),rhuact(nm),dteact(nm)
     &         ,tmxact(nm),tmnact(nm),wndact(nm)
     &         ,temlgm(nm),prclgm(nm),shrlgm(nm),rhulgm(nm),dtelgm(nm)
     &         ,tmxlgm(nm),tmnlgm(nm),wndlgm(nm)
     &         ,tema(nm),prec(nm),rhum(nm),cld(nm),wind(nm),dtem(nm)
     &         ,sunh(nm),tmax(nm),tmin(nm)
     &         ,tema1(nm),prec1(nm),rhum1(nm),cld1(nm),wind1(nm)
     &         ,dtem1(nm),sunh1(nm),tmax1(nm),tmin1(nm)
      dimension xdat(ngr_max),idat(ngr_max)
     
      common /interp/ dist(ngr_max),igri(ngr_max)          
        
      character*5 filext(nm),fext
      
      character*40 wform
      character*40 GCM_model,scen,sceno 
      integer iyr1,iyr2
      integer i,ird_tmax
      character*4 YYYY
      character*150 out_dir      

c ird_tmax = 0 reads and interpolates dte for high resolution 
c            climatological values
c ird_tmax = 1 reads and interpolates tmin & tmax for high resolution 
c            climatological values      
      ird_tmax=0
      
      GCM_model='HadGEM2-AO'
      scen='RCP85car'      
c      scen='histcar'
      ngr_GCM=27840
      sceno='_rcp85_'      
c      sceno='_hist_'
      ngr_car=10260
      iyr1=2006
      iyr2=2100
c      iyr1=1950
c      iyr2=2005   
      
      open(7,file='./anom.test')           
      
      do i = iyr1, iyr2

                  
      write(YYYY,'(i4)') i   
      write(*,*)'Year: ',i

      
      radius = 6370.
   
            
      write(*,*)'Reads GCM grid'      
      

      
      write(*,*)'Reads GCM climatic fields'       
        
       open(20,file='/raid/umccb/CMIP5/'//
     & trim(GCM_model)//'/histcar/temMEAN1970_2000.dat')
       open(21,file='/raid/umccb/CMIP5/'//
     & trim(GCM_model)//'/histcar/tmaxMEAN1970_2000.dat')
       open(22,file='/raid/umccb/CMIP5/'//
     & trim(GCM_model)//'/histcar/tminMEAN1970_2000.dat')
       open(23,file='/raid/umccb/CMIP5/'//
     & trim(GCM_model)//'/histcar/prcMEAN1970_2000.dat')
       open(24,file='/raid/umccb/CMIP5/'//
     & trim(GCM_model)//'/histcar/shrMEAN1970_2000.dat')
       open(25,file='/raid/umccb/CMIP5/'//
     & trim(GCM_model)//'/histcar/rhuMEAN1970_2000.dat')
       open(26,file='/raid/umccb/CMIP5/'//
     & trim(GCM_model)//'/histcar/wndMEAN1970_2000.dat') 

       open(30,file='/raid/umccb/CMIP5/'//
     & trim(GCM_model)//'/'//trim(scen)//'/tem'//YYYY//'.dat')       
       open(31,file='/raid/umccb/CMIP5/'//
     & trim(GCM_model)//'/'//trim(scen)//'/tmax'//YYYY//'.dat')
       open(32,file='/raid/umccb/CMIP5/'//
     & trim(GCM_model)//'/'//trim(scen)//'/tmin'//YYYY//'.dat')
       open(33,file='/raid/umccb/CMIP5/'//
     & trim(GCM_model)//'/'//trim(scen)//'/prc'//YYYY//'.dat')
       open(34,file='/raid/umccb/CMIP5/'//
     & trim(GCM_model)//'/'//trim(scen)//'/shr'//YYYY//'.dat')
       open(35,file='/raid/umccb/CMIP5/'//
     & trim(GCM_model)//'/'//trim(scen)//'/rhu'//YYYY//'.dat')
       open(36,file='/raid/umccb/CMIP5/'//
     & trim(GCM_model)//'/'//trim(scen)//'/wnd'//YYYY//'.dat')
     

       do ig = 1, ngr_GCM
       
        read(20,*) xlo,xla,(tema(m),m=1,nm)
        xlg(ig)=xlo
        xlt(ig)=xla
        read(21,*) xlo,xla,(tmax(m),m=1,nm)
        read(22,*) xlo,xla,(tmin(m),m=1,nm)		
	read(23,*) xlo,xla,(prec(m),m=1,nm)
	read(24,*) xlo,xla,(sunh(m),m=1,nm)
	read(25,*) xlo,xla,(rhum(m),m=1,nm)
	read(26,*) xlo,xla,(wind(m),m=1,nm)
		
	do m=1,nm
	 dtem(m)=tmax(m)-tmin(m)
	 if (dtem(m).lt.0.) then
	   write(*,*)'Negative dtem:',dtem(m),' pixel:',ig,' month:',m
     &      ,'year: MEAN'
	   dtem(m) = 0.
	 endif	
	end do

	read(30,*) xlo,xla,(tema1(m),m=1,nm)		
	read(31,*) xlo,xla,(tmax1(m),m=1,nm)
	read(32,*) xlo,xla,(tmin1(m),m=1,nm)	
	read(33,*) xlo,xla,(prec1(m),m=1,nm)
	read(34,*) xlo,xla,(sunh1(m),m=1,nm)
	read(35,*) xlo,xla,(rhum1(m),m=1,nm)
	read(36,*) xlo,xla,(wind1(m),m=1,nm)
	do m=1,nm
	 dtem1(m)=tmax1(m)-tmin1(m)
	 if (dtem1(m).lt.0.) then
	   write(*,*)'Negative dtem:',dtem1(m),' pixel:',ig,' month:',m
     &      ,'year: ',YYYY	   
	   dtem1(m) = 0.
	 endif	
	end do	
		
	do m = 1, nm
	 temp(ig,m)=tema(m)
	 tmxp(ig,m)=tmax(m)
	 tmnp(ig,m)=tmin(m)
	 prcp(ig,m)=prec(m)  
	 if(rhum(m).lt.5.)rhum(m)=5.       
         if(rhum(m).gt.100.)rhum(m)=100.
	 rhup(ig,m)=rhum(m)
         if(sunh(m).lt.0.)sunh(m)=0.       
         if(sunh(m).gt.100.)sunh(m)=100.
	 shrp(ig,m)=sunh(m)
	 if (wind(m).lt.0.) then
	   write(*,*)'Negative wind:',wind(m),' pixel:',ig,' month:',m
	   wind(m) = 0.
	 endif	
	 wndp(ig,m)=wind(m)	 
	 dtep(ig,m)=dtem(m)
	 
	 tem1(ig,m)=tema1(m)
	 tmx1(ig,m)=tmax1(m)
	 tmn1(ig,m)=tmin1(m)	 
	 prc1(ig,m)=prec1(m)  
	 if(rhum1(m).lt.5.)rhum1(m)=5.       
         if(rhum1(m).gt.100.)rhum1(m)=100.
	 rhu1(ig,m)=rhum1(m)
         if(sunh1(m).lt.0.)sunh1(m)=0.       
         if(sunh1(m).gt.100.)sunh1(m)=100.
	 shr1(ig,m)=sunh1(m)
	 if (wind1(m).lt.0.) then
	   write(*,*)'Negative wind:',wind1(m),' pixel:',ig,' month:',m
	   wind1(m) = 0.
	 endif
	 wnd1(ig,m)=wind1(m)	 	
	 dte1(ig,m)=dtem1(m)	 
	enddo 
       end do                   

       close(20)
       close(21)      
       close(22)
       close(23) 
       close(24)
       close(25)
       close(26)

       close(30)       
       close(31)      
       close(32)
       close(33) 
       close(34)
       close(35)
       close(36)
       
                  
c      end do
      
      write(*,*)'Interpolation'     
      
      open(10,file='./dist.res')  
               
      
c ================================================
c path to be changed by user     

c      open(51,file='/raid3/umccb/clim0017/studeharenne/'//
c     &'caraib/clim/TFE/2.5min/tem_WC.dat') 
c      open(52,file='/raid3/umccb/clim0017/studeharenne/'//
c     &'caraib/clim/TFE/2.5min/prc_WC.dat')		
c      open(53,file='/raid3/umccb/clim0017/studeharenne/'//
c     &'caraib/clim/TFE/2.5min/shr_WC1.dat')
c      open(54,file='/raid3/umccb/clim0017/studeharenne/'//
c     &'caraib/clim/TFE/2.5min/rhu_WC1.dat')
c      if (ird_tmax.eq.0) then
c       open(55,file='/raid3/umccb/clim0017/studeharenne/'//
c     & 'caraib/clim/TFE/2.5min/dte_WC.dat')
c      else
c       open(57,file='/raid3/umccb/clim0017/studeharenne/'//
c     & 'caraib/clim/TFE/2.5min/tmax_WC.dat')
c       open(58,file='/raid3/umccb/clim0017/studeharenne/'//
c     & 'caraib/clim/TFE/2.5min/tmin_WC.dat')     
c      endif       	      
c      open(56,file='/raid3/umccb/clim0017/studeharenne/'//
c     & 'caraib/clim/TFE/2.5min/wnd_WC.dat')
     
c      out_dir = '/raid3/umccb/clim0017/studeharenne/'//
c     & 'caraib/clim/TFE/2.5min/HadGEM2-AO/'
     
c   tem   
      open(51,file=
     &'../clim/Luxemburg/tem_WC.dat')
c   prc 
      open(52,file=
     &'../clim/Luxemburg/prc_WC.dat')
c   shr     		
      open(53,file=
     &'../clim/Luxemburg/shr_WC1.dat')
c   rhu     
      open(54,file=
     &'../clim/Luxemburg/rhu_WC.dat')
      if (ird_tmax.eq.0) then
c   dte      
       open(55,file=
     &'../clim/Luxemburg/dte_WC.dat')
      else
c   Tmax, Tmin      
       open(57,file=
     & '../clim/Luxemburg/tmax_WC.dat')
       open(58,file=
     & '../clim/Luxemburg/tmin_WC.dat')     
      endif  
c   wnd           	      
      open(56,file=
     &'../clim/Luxemburg/wnd_WC.dat')
     
      out_dir='../clim/Luxemburg/HadGEM2-A0/'     
     
      call make_directory(out_dir)
            
      open(81,file=
     &trim(out_dir)//'tem'//trim(sceno)
     &//YYYY//".dat")
      open(82,file=
     &trim(out_dir)//'prc'//trim(sceno)
     &//YYYY//".dat")		
      open(83,file=
     &trim(out_dir)//'shr'//trim(sceno)
     &//YYYY//".dat")
      open(84,file=
     &trim(out_dir)//'rhu'//trim(sceno)
     &//YYYY//".dat")
      if (ird_tmax.eq.0) then
       open(85,file=
     & trim(out_dir)//'dte'//trim(sceno)
     & //YYYY//".dat")
      else
       open(87,file=
     & trim(out_dir)//'tmax'//trim(sceno)
     & //YYYY//".dat")
       open(88,file=
     & trim(out_dir)//'tmin'//trim(sceno)
     & //YYYY//".dat")           
      endif	       
      open(86,file=
     &trim(out_dir)//'wnd'//trim(sceno)
     &//YYYY//".dat")

c=====================================================                           
      icount = 0
      do kg = 1, ngr_car
       icount=icount+1      
c       if (icount.eq.1)write(*,*)'Point Nr: ',kg
       if (icount.eq.1000)icount=0
c       read(50,*)mmm,xlg1,xlt1
       
       read(51,*)xlg1,xlt1,(tem0(im),im=1,nm)
       read(52,*)ylg,ylt,(prc0(im),im=1,nm)
       read(53,*)ylg,ylt,(shr0(im),im=1,nm)
       read(54,*)ylg,ylt,(rhu0(im),im=1,nm)
       if (ird_tmax.eq.0) then        
        read(55,*)ylg,ylt,(dte0(im),im=1,nm)
       else
        read(57,*)ylg,ylt,(tmx0(im),im=1,nm)
	read(58,*)ylg,ylt,(tmn0(im),im=1,nm)       
       endif
       read(56,*)ylg,ylt,(wnd0(im),im=1,nm)
       do im = 1, nm
        if (rhu0(im).lt.5.) rhu0(im)=5.
        if (rhu0(im).gt.100.) rhu0(im)=100.
        if (shr0(im).lt.0.) shr0(im)=0.
        if (shr0(im).gt.100.) shr0(im)=100. 
       enddo
             
       dangl = 3. !(70./111.) !(25./111.)
       ntry = 0
2000   continue       
       num = 0
       do ig = 1, ngr_GCM
        dlg = dabs(xlg(ig)-xlg1)
c	dangl_lg = dangl/dcos(xlt(ig)*pi180)
	if(dlg.le.dangl)then	
c	 write(*,*) 'coucou'
	 dlt = dabs(xlt(ig)-xlt1)
	 if(dlt.le.dangl)then
c	  write(*,*) 'coucou2'
	  num=num+1
	  igri(num)=ig
	  xlg2 = xlg(ig)
	  xlt2 = xlt(ig)
c	   write(*,*) ig,xlg1,xlt1,xlg2,xlt2
c          write(*,*) ig,dlg,dangl,dangl_lg
          call distance(xlg1,xlt1,xlg2,xlt2,dist2)
	  dist(num)=dist2
c	  xdat(ig)=dist(ig)	
c	  write(*,*) dist(1) 
	 endif
	endif
       end do
       write(10,'(2(1x,f8.3),1x,i3)')xlg1,xlt1,num
       
       call sort(dist,igri,num)

       
c       do ig = 1, 8
c        dist(ig)=xdat(ig)
c        if(kg.eq.56) write(*,*) kg,dist(ig),igri(ig)
c	write(*,*) kg,dist(ig),igri(ig)
c       enddo
       
cc       if (num.le.3)then 
cc        write(*,*) 'Num = ',num,' too small (<3)'
cc	stop
cc       endif
       if (ntry.gt.100) then
         write(*,*)'Ntry too large: ', ntry,' ig: ',ig
	 stop
       endif 
       if (num.lt.8) then 
         dangl = dangl*1.5
	 ntry = ntry + 1
	 go to 2000
       endif
         
       num = 8         
       
       call interp_r(temp,temact,num)
       call interp_r(prcp,prcact,num)
       call interp_r(shrp,shract,num)
       call interp_r(rhup,rhuact,num)
       if (ird_tmax.eq.0) then	 
        call interp_r(dtep,dteact,num) 
       else
        call interp_r(tmxp,tmxact,num)
	call interp_r(tmnp,tmnact,num)
       endif     
       call interp_r(wndp,wndact,num)      
       call interp_r(tem1,temlgm,num)
       call interp_r(prc1,prclgm,num)
       call interp_r(shr1,shrlgm,num)
       call interp_r(rhu1,rhulgm,num)
       if (ird_tmax.eq.0) then
        call interp_r(dte1,dtelgm,num) 
       else
        call interp_r(tmx1,tmxlgm,num)
	call interp_r(tmn1,tmnlgm,num)
       endif       	       
       call interp_r(wnd1,wndlgm,num)      
      
c ---------- itest = -1  absolute correction -------------------------
c ---------- itest =  0  weighted aver. of abs. and rel. correct. ----
c ---------- itest =  1  relative correction -------------------------
       
       tcrit=1.
       tmin=273.
       itest=-1
       call correct(tem0,temcor,temact,temlgm,tcrit,tmin,itest)
       
c       do im=0,nm
c        if (temcor(im).ge.50.)then
c	  write(7,*)igr,im,xlg1,xlt1
c	  write(7,*)tem0(im),temcor(im),temact(im),temlgm(im)
c	  write(7,*)jlg1,jlg2,jlt1,jlt2,dist_lg,dist_lt
c	endif
c       end do
       
       pcrit=5.
       pmin=0.2
       itest=0
       call correct(prc0,prccor,prcact,prclgm,pcrit,pmin,itest)
       do im=1,nm
        if(prccor(im).le.0.)then
         write(7,*)'negative precip :',kg,im,xlg1,xlt1
         write(7,*)prc0(im),prccor(im),prcact(im),prclgm(im)	
	 prccor(im)=0.
        endif	 
        if(prccor(im).ge.1000.)then
         write(7,*)'too large precip :',kg,im,xlg1,xlt1
         write(7,*)prc0(im),prccor(im),prcact(im),prclgm(im)
        endif
       end do
       
       scrit=2.
       smin=0.1
       itest=0
       call correct(shr0,shrcor,shract,shrlgm,scrit,smin,itest)
       do im=1,nm
        if(shrcor(im).lt.0.)shrcor(im)=0.
        if(shrcor(im).gt.100.)shrcor(im)=100.
       end do
       
       rcrit=2.
       rmin=0.1
       itest=0
       call correct(rhu0,rhucor,rhuact,rhulgm,rcrit,rmin,itest)
       do im=1,nm
        if(rhucor(im).lt.0.)rhucor(im)=0.
        if(rhucor(im).gt.100.)rhucor(im)=100.
       end do
       
       if (ird_tmax.eq.0) then              
        dcrit=1.
        dmin=0.1
        itest=-1
        call correct(dte0,dtecor,dteact,dtelgm,dcrit,dmin,itest)
        do im=1,nm
         if(dtecor(im).lt.0.)dtecor(im)=0.
        end do
       else
        tcrit=1.
        tmin=273.
        itest=-1
        call correct(tmx0,tmxcor,tmxact,tmxlgm,tcrit,tmin,itest)
	call correct(tmn0,tmncor,tmnact,tmnlgm,tcrit,tmin,itest)
        do im=1,nm
         if(tmxcor(im).lt.tmncor(im))then
	   tmxcor(im)=temcor(im)
	   tmncor(im)=temcor(im)
	 endif
        end do	       
       endif
             
       wcrit=0.5
       wmin=0.1
       itest=1
       call correct(wnd0,wndcor,wndact,wndlgm,wcrit,wmin,itest)
       do im=1,nm
        if(wndcor(im).lt.0.)wndcor(im)=0.
       end do 

       write(wform,*)'(2(1x,f8.3),',nm,'(1x,f6.2))'                    
       write(81,wform)xlg1,xlt1,(temcor(im),im=1,nm)
       
       write(wform,*)'(2(1x,f8.3),',nm,'(1x,f7.2))'       
       write(82,wform)xlg1,xlt1,(prccor(im),im=1,nm)
       
       write(wform,*)'(2(1x,f8.3),',nm,'(1x,f6.2))'       
       write(83,wform)xlg1,xlt1,(shrcor(im),im=1,nm)
       
       write(wform,*)'(2(1x,f8.3),',nm,'(1x,f6.2))'       
       write(84,wform)xlg1,xlt1,(rhucor(im),im=1,nm)
       
       if (ird_tmax.eq.0) then       
        write(wform,*)'(2(1x,f8.3),',nm,'(1x,f6.2))'       
        write(85,wform)xlg1,xlt1,(dtecor(im),im=1,nm)
       else
        write(wform,*)'(2(1x,f8.3),',nm,'(1x,f6.2))'       
        write(87,wform)xlg1,xlt1,(tmxcor(im),im=1,nm)
	write(88,wform)xlg1,xlt1,(tmncor(im),im=1,nm)        
       endif
       
       write(wform,*)'(2(1x,f8.3),',nm,'(1x,f6.2))'       
       write(86,wform)xlg1,xlt1,(wndcor(im),im=1,nm)       
              
      end do
      

      close (50)
      close (51)
      close (52)
      close (53)
      close (54)
      if (ird_tmax.eq.0) then      
       close (55)
      else
       close (57)
       close (58)
      endif
      close (56)
             
      close (81)
      close (82)
      close (83)
      close (84)
      if (ird_tmax.eq.0) then      
       close (85)
      else
       close (87)
       close (88)
      endif
      close (86)  
      
      end do
      
      write(*,*)'End of program'  
                        
      stop      
      end
      
c ********************************************************************** 
      subroutine interp_r(varint,vari,num)
c **********************************************************************      
      implicit double precision (a-h,o-z) 
      integer ngr_max,nm      
      parameter (nm=12,ngr_max=65000)  
c     inputs: igri(1:num),dist(1:num),varint(1:ngr,1:nm),num
c     outputs: vari(1:nm)
      common /interp/ dist(ngr_max),igri(ngr_max)
      dimension varint(ngr_max,nm),vari(nm)
      
      sumwgt = 0.
      do m = 1, nm
       vari(m)=0.
      end do      

      do k = 1, num
        ig = igri(k)
        if (dist(k).le.1.d-3) then	
	  do m = 1, nm
	   vari(m)=varint(ig,m)
	  end do
	  go to 1000
	else
	  weight = 1./dist(k)
	  sumwgt = sumwgt + weight
	  do m = 1, nm
           vari(m)=vari(m)+varint(ig,m)*weight
	  end do
        endif
      end do
      
      do m = 1,nm
       vari(m) = vari(m)/sumwgt
      end do
      
1000  continue
      return
      end
      
      
      
       
c ********************************************************************** 
      subroutine distance(xlg1,xlt1,xlg2,xlt2,dist)
c **********************************************************************      
      implicit double precision (a-h,o-z)
      common /earth/ radius
c 
c   xlg1,xlt1 = long, lat of first point (deg)
c   xlg2,xlt2 = long, lat of second point (deg)
c   radius = Earth radius (km) 
c   dist = distance (km)

       pi180 = 3.1415926535/180.
       c1 = dcos(xlt1*pi180)
       c2 = dcos(xlt2*pi180)
       s1 = dsin(xlt1*pi180)
       s2 = dsin(xlt2*pi180)       
       cdlg = dcos((xlg2-xlg1)*pi180) 
       argum = s1*s2+c1*c2*cdlg      
       if (argum.le.-0.9999999999999d+0) argum = -0.9999999999999d+0 
       if (argum.ge. 0.9999999999999d+0) argum =  0.9999999999999d+0 
       dist = radius*dacos(argum)      
       
       
       return
       end
       
c=======================================================================      
       subroutine correct(q0,qcor,qact,qlgm,qcrit,qmin,itest)
c=======================================================================       
c      This subroutine calculates absolute (dqabs) and relative (dqrel)
c      anomalies of a climatic variable q between a paleoclimatic (lgm) 
c      and a control (act) simulation of a climate model (GCM). 
c      These anomalies are combined with the observed value of q (q0
c      derived from a climatological database) to provide the corrected 
c      value (qcor) of q. The variable can be temperature, precipitation, 
c      relative humidity, etc, and nm=12 monthly values are provided.
c      (Franois et al., Global Planet. Change 16-17, 37-52 1998)
c 
c      INPUTS (to be provided by the user)
c        q0 = observed monthly values of the variable
c        qact = monthly values of the variable in the GCM control run  
c        qlgm = monthly values of the variable in the GCM paleoclimate
c               simulation
c        itest = flag to decide which type of anomalies is used for the
c                corrected value (qcor)
c                itest = -1 absolute anomalies are used
c                itest = 0  weighted averages of absolute and relative
c                           anomalies are used
c                itest = 1  relative anomalies are used         
c        qcrit = critical positive threshold in absolute corrected value 
c                used when itest = 0
c        qmin = parameter (small value) used to avoid excessively high 
c               values of relative anomalies when qact converge towards
c               zero
c      OUTPUT
c        qcor = corrected value of the variable
c-----------------------------------------------------------------------

       implicit double precision (a-h,o-z) 
       parameter (nm=12)
       dimension q0(nm),qcor(nm),qact(nm),qlgm(nm) 
         puis=2.    
         do im=1,nm
          dqabs=qlgm(im)-qact(im)
          qabs=q0(im)+dqabs
          dqrel=q0(im)*(qlgm(im)-qact(im))/(qact(im)+qmin)
          if (itest.eq.-1) xi=1.
          if (itest.eq.1) xi=0.
          if (itest.eq.0) then
            if(qabs.le.0.)then
             xi=0.
            else
             arg=(qabs/qcrit)**puis
             if (arg.lt.30.)then
               xi=1.-dexp(-0.6931472*arg)
              else
               xi=1.
             endif
            endif
          endif
          dqcor=xi*dqabs+(1.-xi)*dqrel
          qcor(im)=q0(im)+dqcor
         end do
       
       return
       end        
       
c=======================================================================
c***********************************************************************
      subroutine charlen(name,kn)
c***********************************************************************
c=======================================================================
      integer kn
      character*4 name
      kn = 1
    1 continue
      kn = kn + 1
      if(name(kn:kn) .ne. ' ') goto 1
      kn = kn - 1
      return 
      end       
      
c=======================================================================      
      subroutine sort(xdat,idat,n)
c=======================================================================            
      integer ngr_max
      parameter (ngr_max=65000)
      dimension xdat(ngr_max),idat(ngr_max)
      real*8 xdat,xdat2
      integer n,jtest,i,idat,idat2


100   continue      
      jtest = 0
     
      
      do i=1,n-1
        if (xdat(i).gt.xdat(i+1)) then
	  jtest = jtest+1
	  xdat2 = xdat(i+1)
	  idat2 = idat(i+1)
	  xdat(i+1) = xdat(i)
	  idat(i+1) = idat(i)
	  xdat(i) = xdat2
	  idat(i) = idat2
	endif
      end do
      
      if (jtest.ge.1) go to 100
      
      return
      end 
       
c***********************************************************************      
      subroutine make_directory(out_dir)
c***********************************************************************
      implicit none
      character*150 out_dir
      character*250 command 
 


      command='mkdir -p '//trim(out_dir)
      call system(command)      

 
      return
      end       
       
       
       
      
